#include <stdio.h>
#include <string.h>
#define N 10
#define RANGE 100

typedef struct element {
	int min;
	int max;
} Element;

/* confronta due struct di tipo Element,
   restituisce -1 se la media di max e min nel 
   primo elemento e'maggiore che nel secondo,
   0 se sono uguali e +1 altrimenti. */
int compare_element(Element e1, Element e2){
	double avg_e1, avg_e2;
	avg_e1 = (double)(e1.max+e1.min)/2.0;
	avg_e2 = (double)(e2.max+e2.min)/2.0;
	if(avg_e1 == avg_e2) return 0;
	return (avg_e1 > avg_e2) ? -1: 1;
}

void swap_element (Element * e1_ptr, Element * e2_ptr){
	Element tmp;
	memcpy(&tmp, e1_ptr, sizeof(Element));
	memcpy(e1_ptr, e2_ptr, sizeof(Element));
	e2_ptr->min = tmp.min;
	e2_ptr->max = tmp.max;
}

void bubble_sort(Element v[], int size, int(*compare)(Element, Element )){
	int pass,i;
	for (pass= 1; pass <size; pass ++) {
		for (i=0; i< size-pass; i++) {
			if ((*compare)(v[i], v[i+1])==-1){
				swap_element(&v[i], &v[i+1]);
			}
		}
	}
}
void randomize(Element vect[], int size, int range){
	static int i, tmp;
	
	for(i=0; i < size; i++) {
		vect [ i ].min = rand() % range;
		vect [ i ].max = rand() % range;
		if (vect[i].min > vect[i].max) {
			tmp=vect[i].min;
			vect[i].min = vect[i].max;
			vect[i].max = tmp;
		}
	}
}

void print_vect(Element v [], int size){
	int i;
	for (i=0; i< size; i++){
		printf("(%d,%d) ", v[i].min, v[i].max);
	}
	printf("\n");
}

int main(void){
	int seed;
	Element v [N];
	
	printf("Inserire il seed per il generatore di numeri casuali\n");
	scanf("%d", &seed);
	randomize(v, N, RANGE);
	print_vect(v, N);
	bubble_sort(v, N, compare_element);
	print_vect(v, N);	
	
}
